package com.huimv.beeboxs.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.huimv.beeboxs.common.token.TokenSign;
import com.huimv.beeboxs.common.utils.Result;
import com.huimv.beeboxs.entity.AccountGroup;
import com.huimv.beeboxs.entity.Group;
import com.huimv.beeboxs.service.IAccountGroupService;
import com.huimv.beeboxs.service.IGroupService;
import com.huimv.beeboxs.service.ISysAccountMultilevelService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

@CrossOrigin
@RestController
@RequestMapping("/admin/group")
public class SysGroupController {

    @Autowired
    private IGroupService groupService;

    @Autowired
    private IAccountGroupService accountGroupService;
    @Autowired
    private ISysAccountMultilevelService accountMultilevelService;

    @PostMapping("/add")
    public Result addGroup (@RequestBody Group group, HttpServletRequest request){
        Integer userId = TokenSign.getMemberIdByJwtToken(request);
        return groupService.addGroup(group,userId);
    }


    @PostMapping("/edit")
    public Result updateGroup(@RequestBody Group group ){
        return groupService.updateGroup( group);
    }

    @RequestMapping("/remove")
    public Result removeGroup(@RequestParam("groupId") Integer groupId) {

        accountGroupService.remove(new QueryWrapper<AccountGroup>().in("group_id",groupId));
        return groupService.removeGroup(groupId);
    }

    @PostMapping("/list")
    public IPage<Group> listGroup(@RequestBody Map map , HttpServletRequest request) {
        Integer userId = TokenSign.getMemberIdByJwtToken(request);
        List<Integer> allChildId = accountMultilevelService.getAllChildId(userId);
        return groupService.listGroup(map,allChildId);
    }
}
